Index: NEMO/branches/2020/ticket2487/src/ICE/iceistate.F90
===================================================================
--- NEMO/branches/2020/ticket2487/src/ICE/iceistate.F90	(revision 13294)
+++ NEMO/branches/2020/ticket2487/src/ICE/iceistate.F90	(revision 13299)
@@ -18,5 +18,5 @@
    USE oce            ! dynamics and tracers variables
    USE dom_oce        ! ocean domain
-   USE sbc_oce , ONLY : sst_m, sss_m, ln_ice_embd 
+   USE sbc_oce , ONLY : sst_m, sss_m, ln_ice_embd , ln_ice_sladj
    USE sbc_ice , ONLY : tn_ice, snwice_mass, snwice_mass_b
    USE eosbn2         ! equation of state
@@ -379,7 +379,7 @@
       at_i(:,:) = SUM( a_i, dim=3 )
       !
-      !----------------------------------------------
-      ! 3) Snow-ice mass (case ice is fully embedded)
-      !----------------------------------------------
+      !-----------------
+      ! 3) Snow-ice mass
+      !-----------------
       snwice_mass  (:,:) = tmask(:,:,1) * SUM( rhos * v_s(:,:,:) + rhoi * v_i(:,:,:), dim=3  )   ! snow+ice mass
       snwice_mass_b(:,:) = snwice_mass(:,:)
@@ -428,5 +428,5 @@
             END DO
          ENDIF
-      ELSE
+      ELSEIF( ln_ice_sladj ) THEN       ! adjustment of sea level due to initial snow+ice mass
          z1_area = 1.0_wp / glob_sum( 'iceistate', e1e2t(:,:) )
          zsshadj = glob_sum( 'iceistate', e1e2t(:,:) * snwice_mass(:,:) ) * r1_rau0 * z1_area
@@ -438,6 +438,6 @@
          rsshadj = zsshadj
 #endif
-         WRITE(ctmp1,'(A34,F10.6,A32)') 'iceistate:   mean ssh adjusted by ', -1.0_wp * zsshadj, ' m to compensate for the initial'
-         CALL ctl_warn( ctmp1,          '             ice+snow mass' )
+         IF(lwp) WRITE(numout,'(A35,F10.6,A21)') 'iceistate:   sea level adjusted by ', -1.0_wp * zsshadj, ' m to compensate for'
+         IF(lwp) WRITE(numout,*) '             the initial snow+ice mass'
          sshn(:,:) = sshn(:,:) - zsshadj
          sshb(:,:) = sshb(:,:) - zsshadj
Index: NEMO/branches/2020/ticket2487/src/OCE/SBC/sbc_oce.F90
===================================================================
--- NEMO/branches/2020/ticket2487/src/OCE/SBC/sbc_oce.F90	(revision 13294)
+++ NEMO/branches/2020/ticket2487/src/OCE/SBC/sbc_oce.F90	(revision 13299)
@@ -50,4 +50,6 @@
    !                                             !: =F levitating ice (no presure effect) with mass and salt exchanges
    !                                             !: =T embedded sea-ice (pressure effect + mass and salt exchanges)
+   LOGICAL , PUBLIC ::   ln_ice_sladj   !: flag to enable initial sea-level adjustment due to initial sea-ice and snow mass
+                                                 ! (this option has no effect if ln_ice_embd equals .TRUE.)
    INTEGER , PUBLIC ::   nn_components  !: flag for sbc module (including sea-ice) coupling mode (see component definition below) 
    INTEGER , PUBLIC ::   nn_fwb         !: FreshWater Budget: 
Index: NEMO/branches/2020/ticket2487/src/OCE/SBC/sbcice_cice.F90
===================================================================
--- NEMO/branches/2020/ticket2487/src/OCE/SBC/sbcice_cice.F90	(revision 13294)
+++ NEMO/branches/2020/ticket2487/src/OCE/SBC/sbcice_cice.F90	(revision 13299)
@@ -271,5 +271,5 @@
                END DO
             ENDIF
-         ELSE
+         ELSEIF( ln_ice_sladj ) THEN       ! adjustment of the sea level due to initial snow+ice mass
             z1_area = 1.0_wp / glob_sum( 'sbcice_cice', e1e2t(:,:) )
             zsshadj = glob_sum( 'sbcice_cice', e1e2t(:,:) * snwice_mass(:,:) ) * r1_rau0 * z1_area
@@ -281,6 +281,6 @@
             rsshadj = zsshadj
 #endif
-            WRITE(ctmp1,'(A36,F10.6,A24)') 'sbcice_cice:   mean ssh adjusted by ', -1.0_wp * zsshadj, ' m to compensate for the'
-            CALL ctl_warn( ctmp1,          '               initial ice+snow mass' )
+            IF(lwp) WRITE(numout,'(A35,F10.6,A21)') 'iceistate:   sea level adjusted by ', -1.0_wp * zsshadj, ' m to compensate for'
+            IF(lwp) WRITE(numout,*) '             the initial snow+ice mass'
             sshn(:,:) = sshn(:,:) - zsshadj
             sshb(:,:) = sshb(:,:) - zsshadj
Index: NEMO/branches/2020/ticket2487/src/OCE/SBC/sbcmod.F90
===================================================================
--- NEMO/branches/2020/ticket2487/src/OCE/SBC/sbcmod.F90	(revision 13294)
+++ NEMO/branches/2020/ticket2487/src/OCE/SBC/sbcmod.F90	(revision 13299)
@@ -94,5 +94,5 @@
          &             ln_usr   , ln_flx   , ln_blk       ,                          &
          &             ln_cpl   , ln_mixcpl, nn_components,                          &
-         &             nn_ice   , ln_ice_embd,                                       &
+         &             nn_ice   , ln_ice_embd, ln_ice_sladj,                         &
          &             ln_traqsr, ln_dm2dc ,                                         &
          &             ln_rnf   , nn_fwb   , ln_ssr   , ln_isf    , ln_apr_dyn ,     &
@@ -146,4 +146,5 @@
          WRITE(numout,*) '         ice management in the sbc (=0/1/2/3)       nn_ice        = ', nn_ice
          WRITE(numout,*) '         ice embedded into ocean                    ln_ice_embd   = ', ln_ice_embd
+         WRITE(numout,*) '         sea-level adj. due to initial ice/snow     ln_ice_sladj  = ', ln_ice_sladj
          WRITE(numout,*) '      Misc. options of sbc : '
          WRITE(numout,*) '         Light penetration in temperature Eq.       ln_traqsr     = ', ln_traqsr