Index: /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SHARED/namelist_ice_ref
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SHARED/namelist_ice_ref	(revision 13342)
+++ /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SHARED/namelist_ice_ref	(revision 13343)
@@ -95,7 +95,7 @@
       rn_creepl     =   2.0e-9        !     creep limit [1/s]
       rn_ecc        =   2.0           !     eccentricity of the elliptical yield curve          
-      nn_nevp       = 120             !     number of EVP subcycles                             
+      nn_nevp       = 100             !     number of EVP subcycles                             
       rn_relast     =   0.333         !     ratio of elastic timescale to ice time step: Telast = dt_ice * rn_relast 
-                                      !        advised value: 1/3 (rn_nevp=120) or 1/9 (rn_nevp=300)
+                                      !        advised value: 1/3 (nn_nevp=100) or 1/9 (nn_nevp=300)
    ln_rhg_chkcvg    = .false.         !  check convergence of rheology (outputs: file ice_cvg.nc & variable uice_cvg)
 /
@@ -111,5 +111,5 @@
 !------------------------------------------------------------------------------
    rn_cio           =   5.0e-03       !  ice-ocean drag coefficient (-)
-   nn_snwfra        =   0             !  calculate the fraction of ice covered by snow (for zdf and albedo)
+   nn_snwfra        =   2             !  calculate the fraction of ice covered by snow (for zdf and albedo)
                                       !     = 0  fraction = 1 (if snow) or 0 (if no snow)
                                       !     = 1  fraction = 1-exp(-0.2*rhos*hsnw) [MetO formulation]
@@ -124,5 +124,5 @@
    ln_cndflx        = .false.         !  Use conduction flux as surface boundary conditions (i.e. for Jules coupling)
       ln_cndemulate = .false.         !     emulate conduction flux (if not provided in the inputs)
-   nn_qtrice        = 0               !  Solar flux transmitted thru the surface scattering layer:
+   nn_qtrice        =   1             !  Solar flux transmitted thru the surface scattering layer:
                                       !     = 0  Grenfell and Maykut 1977 (depends on cloudiness and is 0 when there is snow) 
                                       !     = 1  Lebrun 2019 (equals 0.3 anytime with different melting/dry snw conductivities)
@@ -190,6 +190,6 @@
 &namthd_pnd     !   Melt ponds
 !------------------------------------------------------------------------------
-   ln_pnd            = .false.        !  activate melt ponds or not
-      ln_pnd_LEV     = .false.        !  level ice melt ponds (from Flocco et al 2007,2010 & Holland et al 2012)
+   ln_pnd            = .true.         !  activate melt ponds or not
+      ln_pnd_LEV     = .true.         !  level ice melt ponds (from Flocco et al 2007,2010 & Holland et al 2012)
          rn_apnd_min =   0.15         !     minimum ice fraction that contributes to melt pond. range: 0.0 -- 0.15 ??
          rn_apnd_max =   0.85         !     maximum ice fraction that contributes to melt pond. range: 0.7 -- 0.85 ??
Index: /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SHARED/namelist_ref
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SHARED/namelist_ref	(revision 13342)
+++ /NEMO/releases/r4.0/r4.0-HEAD/cfgs/SHARED/namelist_ref	(revision 13343)
@@ -1054,10 +1054,10 @@
    rn_bshear   =   1.e-20  ! background shear (>0) currently a numerical threshold (do not change it)
    nn_pdl      =   1       !  Prandtl number function of richarson number (=1, avt=pdl(Ri)*avm) or not (=0, avt=avm)
-   nn_mxl      =   2       !  mixing length: = 0 bounded by the distance to surface and bottom
+   nn_mxl      =   3       !  mixing length: = 0 bounded by the distance to surface and bottom
    !                       !                 = 1 bounded by the local vertical scale factor
    !                       !                 = 2 first vertical derivative of mixing length bounded by 1
    !                       !                 = 3 as =2 with distinct dissipative an mixing length scale
    ln_mxl0     = .true.    !  surface mixing length scale = F(wind stress) (T) or not (F)
-      nn_mxlice    = 0        ! type of scaling under sea-ice
+      nn_mxlice    = 2        ! type of scaling under sea-ice
                               !    = 0 no scaling under sea-ice
                               !    = 1 scaling with constant sea-ice thickness